=== debian/changelog ===
rabbitmq-server (3.4.3-2~cloud0) trusty-kilo; urgency=medium

  * New update for the Ubuntu Cloud Archive.

 -- Openstack Ubuntu Testing Bot <openstack-testing-bot@ubuntu.com>  Mon, 02 Feb 2015 12:03:36 +0000

rabbitmq-server (3.4.3-2) unstable; urgency=medium

  * Restore missing changes from 3.4.2-4.

 -- James Page <james.page@ubuntu.com>  Mon, 02 Feb 2015 07:44:33 +0200

rabbitmq-server (3.4.3-1) unstable; urgency=medium

  * New upstream point release.

 -- James Page <james.page@ubuntu.com>  Wed, 28 Jan 2015 16:12:32 +0000

rabbitmq-server (3.4.2-4) unstable; urgency=medium

  * Re-added /usr/lib/erlang/lib /var/lib/rabbitmq/mnesia and
    /var/log/rabbitmq which I removed form the package by mistake on the last
    upload.

 -- Thomas Goirand <zigo@debian.org>  Wed, 28 Jan 2015 13:11:02 +0000

rabbitmq-server (3.4.2-3) unstable; urgency=medium

  * Removes debian/README which is useless (Closes: #703021).
  * Provides a default /etc/rabbitmq/rabbitmq-env.conf (Closes: #543638).

 -- Thomas Goirand <zigo@debian.org>  Tue, 27 Jan 2015 15:08:08 +0100

rabbitmq-server (3.4.2-2) unstable; urgency=medium

  * d/rabbitmq-server.dirs: Restore missing /etc/rabbitmq directory
    (LP: #1410155).

 -- James Page <james.page@ubuntu.com>  Tue, 13 Jan 2015 09:53:47 +0000

rabbitmq-server (3.4.2-1) unstable; urgency=medium

  [ James Page ]
  * New upstream point release.
  * d/control: Update for new maintainer information, add VCS repository
    locations.
  * d/source/format: Switch packaging to source format 3.0 (quilt).
  * d/compat,control: Bump debhelper compat level to 9.
  * d/*: wrap-and-sort.
  * d/*: Move to standard debhelper, drop use of cdbs.
  * d/rules,control,rabbitmq-server.service: Add systemd service
    configuration.
  * d/control: Bumped Standards-Version 3.9.6, no changes.

  [ Thomas Goirand ]
  * d/copyright: Rewrote as format 1.0.

 -- James Page <james.page@ubuntu.com>  Fri, 19 Dec 2014 11:09:20 +0000

rabbitmq-server (3.4.1-1) unstable; urgency=high

  * New upstream release.

 -- Blair Hester <bhester@gopivotal.com>  Tue, 04 Nov 2014 07:33:44 +0100

rabbitmq-server (3.3.5-1) unstable; urgency=low

  * New upstream release:
    - Provides unminimized versions of all bundled Javascript
      libraries (Closes: #736781).
  * d/control: Added Blair Hester to Uploaders, dropped Emile Joubert 
    (thanks for all your work Emile!).

 -- Blair Hester <bhester@gopivotal.com>  Tue, 12 Aug 2014 11:47:14 +0100

rabbitmq-server (3.3.4-1) unstable; urgency=low

  * New upstream release

 -- Emile Joubert <emile@rabbitmq.com>  Tue, 24 Jun 2014 18:00:48 +0100

rabbitmq-server (3.3.3-1) unstable; urgency=low

  * New upstream release

 -- Emile Joubert <emile@rabbitmq.com>  Tue, 17 Jun 2014 16:59:14 +0100

rabbitmq-server (3.3.1-1) unstable; urgency=low

  * New upstream release

 -- Emile Joubert <emile@rabbitmq.com>  Tue, 29 Apr 2014 21:05:49 +0100

rabbitmq-server (3.3.0-1) unstable; urgency=low

  * New upstream release

 -- Emile Joubert <emile@rabbitmq.com>  Wed, 02 Apr 2014 16:23:08 +0100

rabbitmq-server (3.2.4-1.1) unstable; urgency=high

  * Non-maintainer upload.
  * Bind on 127.0.0.1 by default, to avoid listening on all ipv6 interface with
    guest/guest as default configured user. Note that this only fixes *new*
    installation, and that any already existing setup will have to edit the
    /etc/rabbitmq/rabbitmq-env.conf manually if affected. (Closes: #727607)
  * Removed useless and deprecated DM-Upload field.
  * Cleans plugins-src/rabbitmq-server to be able to build twice. Also cleans
    debian/postrm which is generated from debian/postrm.in and plugins/README.

 -- Thomas Goirand <zigo@debian.org>  Mon, 31 Mar 2014 06:11:46 +0000
