=== debian/changelog ===
rabbitmq-server (3.5.4-1) unstable; urgency=medium

  * New upstream release.

 -- James Page <james.page@ubuntu.com>  Tue, 04 Aug 2015 14:52:31 +0200

rabbitmq-server (3.5.1-2) unstable; urgency=medium

  [ Tony Breeds ]
  * systemd: Ensure that rabbitmq has started before marking service as
    running (LP: #1449056).

  [ James Page ]
  * systemd: Drop use of /etc/default/rabbitmq-server.

 -- James Page <james.page@ubuntu.com>  Tue, 02 Jun 2015 11:40:59 +0100

rabbitmq-server (3.5.1-1) unstable; urgency=medium

  * New upstream release.

 -- James Page <james.page@ubuntu.com>  Wed, 13 May 2015 21:35:52 +0100
